/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.gui.components;

import javax.swing.JFrame;
import org.apache.log4j.Logger;
import org.visnow.vn.system.main.VisNow;

/**
 *
 * @author szpak
 */
public class NumericTextFieldTestFrame extends javax.swing.JFrame
{
    private static final Logger LOGGER = Logger.getLogger(NumericTextFieldTestFrame.class);

    /**
     * Creates new form NumericTextFieldTestFrame
     */
    public NumericTextFieldTestFrame()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        valueTF = new org.visnow.vn.gui.components.NumericTextField();
        revertCB = new javax.swing.JCheckBox();
        jLabel2 = new javax.swing.JLabel();
        jComboBox1 = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jComboBox2 = new javax.swing.JComboBox();
        jLabel3 = new javax.swing.JLabel();
        jComboBox3 = new javax.swing.JComboBox();
        jButton1 = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        minTF = new org.visnow.vn.gui.components.NumericTextField();
        jLabel5 = new javax.swing.JLabel();
        maxTF = new org.visnow.vn.gui.components.NumericTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        getContentPane().setLayout(new java.awt.GridBagLayout());

        valueTF.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.INT);
        valueTF.setMin(-123);
        valueTF.setValue(3345);
        valueTF.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                valueTFUserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(valueTF, gridBagConstraints);

        revertCB.setText("revert if out of bounds");
        revertCB.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                revertCBActionPerformed(evt);
            }
        });
        getContentPane().add(revertCB, new java.awt.GridBagConstraints());

        jLabel2.setText("Convert and set field type:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(jLabel2, gridBagConstraints);

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "DOUBLE", "FLOAT", "LONG", "INT", "SHORT", "BYTE" }));
        jComboBox1.setSelectedIndex(3);
        jComboBox1.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jComboBox1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(jComboBox1, gridBagConstraints);

        jLabel1.setText("Set max:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(jLabel1, gridBagConstraints);

        jComboBox2.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "DOUBLE", "FLOAT", "LONG", "INT", "SHORT", "BYTE" }));
        jComboBox2.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jComboBox2ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(jComboBox2, gridBagConstraints);

        jLabel3.setText("Set min:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(jLabel3, gridBagConstraints);

        jComboBox3.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "DOUBLE", "FLOAT", "LONG", "INT", "SHORT", "BYTE" }));
        jComboBox3.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jComboBox3ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(jComboBox3, gridBagConstraints);

        jButton1.setText("setText 1234");
        jButton1.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButton1ActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        getContentPane().add(jButton1, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel4.setText("Min:");
        jPanel1.add(jLabel4, new java.awt.GridBagConstraints());

        minTF.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.LONG);
        minTF.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                minTFUserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(minTF, gridBagConstraints);

        jLabel5.setText("Max:");
        jPanel1.add(jLabel5, new java.awt.GridBagConstraints());

        maxTF.setFieldType(org.visnow.vn.gui.components.NumericTextField.FieldType.LONG);
        maxTF.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener()
        {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)
            {
                maxTFUserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(maxTF, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jPanel1, gridBagConstraints);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jComboBox2ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jComboBox2ActionPerformed
    {//GEN-HEADEREND:event_jComboBox2ActionPerformed
        String selectedType = (String) jComboBox2.getSelectedItem();

        LOGGER.info("Set MAX " + selectedType);
        try {
            if (selectedType == "DOUBLE") valueTF.setValue(Double.MAX_VALUE);
            else if (selectedType == "FLOAT") valueTF.setValue(Float.MAX_VALUE);
            else if (selectedType == "LONG") valueTF.setValue(Long.MAX_VALUE);
            else if (selectedType == "INT") valueTF.setValue(Integer.MAX_VALUE);
            else if (selectedType == "SHORT") valueTF.setValue(Short.MAX_VALUE);
            else if (selectedType == "BYTE") valueTF.setValue(Byte.MAX_VALUE);
        } catch (Exception e) {
            LOGGER.info("exception while setValue", e);
        }
    }//GEN-LAST:event_jComboBox2ActionPerformed

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jComboBox1ActionPerformed
    {//GEN-HEADEREND:event_jComboBox1ActionPerformed
        String selectedType = (String) jComboBox1.getSelectedItem();

        LOGGER.info("Cast to " + selectedType);
        if (selectedType == "DOUBLE") {
            valueTF.setFieldType(NumericTextField.FieldType.DOUBLE);
            minTF.setFieldType(NumericTextField.FieldType.DOUBLE);
            minTF.setMin(-Double.MAX_VALUE);
            minTF.setMax(Double.MAX_VALUE);
            maxTF.setFieldType(NumericTextField.FieldType.DOUBLE);
            maxTF.setMin(-Double.MAX_VALUE);
            maxTF.setMax(Double.MAX_VALUE);
        } else if (selectedType == "FLOAT") {
            valueTF.setFieldType(NumericTextField.FieldType.FLOAT);
            minTF.setFieldType(NumericTextField.FieldType.FLOAT);
            minTF.setMin(-Float.MAX_VALUE);
            minTF.setMax(Float.MAX_VALUE);
            maxTF.setFieldType(NumericTextField.FieldType.FLOAT);
            maxTF.setMin(-Float.MAX_VALUE);
            maxTF.setMax(Float.MAX_VALUE);
        } else if (selectedType == "LONG") {
            valueTF.setFieldType(NumericTextField.FieldType.LONG);
            minTF.setFieldType(NumericTextField.FieldType.LONG);
            minTF.setMax(Long.MAX_VALUE);
            minTF.setMin(Long.MIN_VALUE);            
            maxTF.setFieldType(NumericTextField.FieldType.LONG);
            maxTF.setMax(Long.MAX_VALUE);
            maxTF.setMin(Long.MIN_VALUE);            
        } else if (selectedType == "INT") {
            valueTF.setFieldType(NumericTextField.FieldType.INT);
            minTF.setFieldType(NumericTextField.FieldType.INT);
            minTF.setMax(Integer.MAX_VALUE);
            minTF.setMin(Integer.MIN_VALUE);            
            maxTF.setFieldType(NumericTextField.FieldType.INT);
            maxTF.setMax(Integer.MAX_VALUE);
            maxTF.setMin(Integer.MIN_VALUE);            
        } else if (selectedType == "SHORT") {
            valueTF.setFieldType(NumericTextField.FieldType.SHORT);
            minTF.setFieldType(NumericTextField.FieldType.SHORT);
            minTF.setMax(Short.MAX_VALUE);
            minTF.setMin(Short.MIN_VALUE);            
            maxTF.setFieldType(NumericTextField.FieldType.SHORT);
            maxTF.setMax(Short.MAX_VALUE);
            maxTF.setMin(Short.MIN_VALUE);            
        } else if (selectedType == "BYTE") {
            valueTF.setFieldType(NumericTextField.FieldType.BYTE);
            minTF.setFieldType(NumericTextField.FieldType.BYTE);
            minTF.setMax(Byte.MAX_VALUE);
            minTF.setMin(Byte.MIN_VALUE);            
            maxTF.setFieldType(NumericTextField.FieldType.BYTE);
            maxTF.setMax(Byte.MAX_VALUE);
            maxTF.setMin(Byte.MIN_VALUE);            
        }
    }//GEN-LAST:event_jComboBox1ActionPerformed

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButton1ActionPerformed
    {//GEN-HEADEREND:event_jButton1ActionPerformed
        valueTF.setText("1234");
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jComboBox3ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jComboBox3ActionPerformed
    {//GEN-HEADEREND:event_jComboBox3ActionPerformed
        String selectedType = (String) jComboBox3.getSelectedItem();
        LOGGER.info("Set MAX " + selectedType);
        try {
            if (selectedType == "DOUBLE") valueTF.setValue(Double.MIN_VALUE);
            else if (selectedType == "FLOAT") valueTF.setValue(Float.MIN_VALUE);
            else if (selectedType == "LONG") valueTF.setValue(Long.MIN_VALUE);
            else if (selectedType == "INT") valueTF.setValue(Integer.MIN_VALUE);
            else if (selectedType == "SHORT") valueTF.setValue(Short.MIN_VALUE);
            else if (selectedType == "BYTE") valueTF.setValue(Byte.MIN_VALUE);
        } catch (Exception e) {
            LOGGER.info("exception while setValue", e);
        }

    }//GEN-LAST:event_jComboBox3ActionPerformed

    private void minTFUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_minTFUserChangeAction
    {//GEN-HEADEREND:event_minTFUserChangeAction
        valueTF.setMin(minTF.getValue());
    }//GEN-LAST:event_minTFUserChangeAction

    private void maxTFUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_maxTFUserChangeAction
    {//GEN-HEADEREND:event_maxTFUserChangeAction
        valueTF.setMax(maxTF.getValue());
    }//GEN-LAST:event_maxTFUserChangeAction

    private void revertCBActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_revertCBActionPerformed
    {//GEN-HEADEREND:event_revertCBActionPerformed
        valueTF.setRevertIfOutOfBounds(revertCB.isSelected());
    }//GEN-LAST:event_revertCBActionPerformed

    private void valueTFUserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_valueTFUserChangeAction
    {//GEN-HEADEREND:event_valueTFUserChangeAction
        LOGGER.debug("User change: " + valueTF.getValue() + " " + valueTF.getText());
    }//GEN-LAST:event_valueTFUserChangeAction

    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        VisNow.initLogging(true);
        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable()
        {
            public void run()
            {
                JFrame f = new NumericTextFieldTestFrame();
                f.pack();
                f.setLocationRelativeTo(null);
                f.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JComboBox jComboBox2;
    private javax.swing.JComboBox jComboBox3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPanel jPanel1;
    private org.visnow.vn.gui.components.NumericTextField maxTF;
    private org.visnow.vn.gui.components.NumericTextField minTF;
    private javax.swing.JCheckBox revertCB;
    private org.visnow.vn.gui.components.NumericTextField valueTF;
    // End of variables declaration//GEN-END:variables
}
